///////////////////////////////////////////////
//  t\퐧䃉Cu
//  ֐͈ȉ
//    lcd_init()    ----- 
//    lcd_cmd(cmd)  ----- R}ho
//    lcd_data(chr) ----- P\o
//    lcd_str(ptr)  ----- \o
//    lcd_clear()   ----- S
//////////////////////////////////////////////

//////// f[^o̓Tu֐
void lcd_out(char code, int flag)
{
	if(code & 0x80)
		output_high(DB7);
	else
		output_low(DB7);
	if(code & 0x40)
		output_high(DB6);
	else
		output_low(DB6);
	if(code & 0x20)
		output_high(DB5);
	else
		output_low(DB5);
	if(code & 0x10)
		output_high(DB4);
	else
		output_low(DB4);
	if (flag == 0)
		output_high(RS);		//\f[^̏ꍇ
	else
		output_low(RS);		//R}hf[^̏ꍇ
	delay_cycles(1);			//NOP		
	output_high(STB);			//strobe out
	delay_cycles(2);			//NOP
	output_low(STB);			//reset strobe
}
//////// P\֐
void lcd_data(char asci)
{
	lcd_out(asci, 0);			//ʂSrbgo
	lcd_out(asci<<4, 0);		//ʂSrbgo
	delay_us(50);				//50sec҂
}
/////// \֐
void lcd_str(char* ptr)
{
	while(*ptr != 0)
		lcd_data(*ptr++);
}
/////// R}ho͊֐
void lcd_cmd(char cmd)
{
	lcd_out(cmd, 1);			//ʂSrbgo
	lcd_out(cmd<<4, 1);		//ʂSrbgo
	delay_ms(2);				//2msec҂
}
/////// S֐
void lcd_clear()
{
	lcd_cmd(0x01);			//R}ho
	delay_ms(15);				//15msec҂
}
/////// ֐
void lcd_init()
{
	delay_ms(30);
	lcd_out(0x30, 1);			//8bit mode set
	delay_ms(5);
	lcd_out(0x30, 1);			//8bit mode set
	delay_ms(1);
	lcd_out(0x30, 1);			//8bit mode set
	delay_ms(1);
	lcd_out(0x20, 1);			//4bit mode set
	delay_ms(1);
	lcd_cmd(0x2E);			//DL=0 4bit mode
	lcd_cmd(0x08);			//display off C=D=B=0
	lcd_cmd(0x0D);			//display on C=D=1 B=0
	lcd_cmd(0x06);			//entry I/D=1 S=0
	lcd_cmd(0x02);			//cursor home
}

